# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.4.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class AbuseMessage(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'message': 'str',
        'by_moderator': 'bool',
        'created_at': 'datetime',
        'account': 'AccountSummary'
    }

    attribute_map = {
        'id': 'id',
        'message': 'message',
        'by_moderator': 'byModerator',
        'created_at': 'createdAt',
        'account': 'account'
    }

    def __init__(self, id=None, message=None, by_moderator=None, created_at=None, account=None, local_vars_configuration=None):  # noqa: E501
        """AbuseMessage - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._message = None
        self._by_moderator = None
        self._created_at = None
        self._account = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if message is not None:
            self.message = message
        if by_moderator is not None:
            self.by_moderator = by_moderator
        if created_at is not None:
            self.created_at = created_at
        if account is not None:
            self.account = account

    @property
    def id(self):
        """Gets the id of this AbuseMessage.  # noqa: E501


        :return: The id of this AbuseMessage.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AbuseMessage.


        :param id: The id of this AbuseMessage.  # noqa: E501
        :type id: int
        """

        self._id = id

    @property
    def message(self):
        """Gets the message of this AbuseMessage.  # noqa: E501


        :return: The message of this AbuseMessage.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this AbuseMessage.


        :param message: The message of this AbuseMessage.  # noqa: E501
        :type message: str
        """

        self._message = message

    @property
    def by_moderator(self):
        """Gets the by_moderator of this AbuseMessage.  # noqa: E501


        :return: The by_moderator of this AbuseMessage.  # noqa: E501
        :rtype: bool
        """
        return self._by_moderator

    @by_moderator.setter
    def by_moderator(self, by_moderator):
        """Sets the by_moderator of this AbuseMessage.


        :param by_moderator: The by_moderator of this AbuseMessage.  # noqa: E501
        :type by_moderator: bool
        """

        self._by_moderator = by_moderator

    @property
    def created_at(self):
        """Gets the created_at of this AbuseMessage.  # noqa: E501


        :return: The created_at of this AbuseMessage.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this AbuseMessage.


        :param created_at: The created_at of this AbuseMessage.  # noqa: E501
        :type created_at: datetime
        """

        self._created_at = created_at

    @property
    def account(self):
        """Gets the account of this AbuseMessage.  # noqa: E501


        :return: The account of this AbuseMessage.  # noqa: E501
        :rtype: AccountSummary
        """
        return self._account

    @account.setter
    def account(self, account):
        """Sets the account of this AbuseMessage.


        :param account: The account of this AbuseMessage.  # noqa: E501
        :type account: AccountSummary
        """

        self._account = account

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AbuseMessage):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AbuseMessage):
            return True

        return self.to_dict() != other.to_dict()
