# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.4.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class InlineObject11(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'state': 'AbuseStateSet',
        'moderation_comment': 'str'
    }

    attribute_map = {
        'state': 'state',
        'moderation_comment': 'moderationComment'
    }

    def __init__(self, state=None, moderation_comment=None, local_vars_configuration=None):  # noqa: E501
        """InlineObject11 - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._state = None
        self._moderation_comment = None
        self.discriminator = None

        if state is not None:
            self.state = state
        if moderation_comment is not None:
            self.moderation_comment = moderation_comment

    @property
    def state(self):
        """Gets the state of this InlineObject11.  # noqa: E501


        :return: The state of this InlineObject11.  # noqa: E501
        :rtype: AbuseStateSet
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this InlineObject11.


        :param state: The state of this InlineObject11.  # noqa: E501
        :type state: AbuseStateSet
        """

        self._state = state

    @property
    def moderation_comment(self):
        """Gets the moderation_comment of this InlineObject11.  # noqa: E501

        Update the report comment visible only to the moderation team  # noqa: E501

        :return: The moderation_comment of this InlineObject11.  # noqa: E501
        :rtype: str
        """
        return self._moderation_comment

    @moderation_comment.setter
    def moderation_comment(self, moderation_comment):
        """Sets the moderation_comment of this InlineObject11.

        Update the report comment visible only to the moderation team  # noqa: E501

        :param moderation_comment: The moderation_comment of this InlineObject11.  # noqa: E501
        :type moderation_comment: str
        """

        self._moderation_comment = moderation_comment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineObject11):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineObject11):
            return True

        return self.to_dict() != other.to_dict()
